<?php
	include "include/globals.php";
	include "include/mailfunctions.php";

	$mbox = open_mailbox();

	if(isset($_REQUEST["newfolder"])) {
		// create the new folder under the folder currently highlighted
		if ($_REQUEST["infolder"] != "") {
			$check = is_createmailbox($mbox, urldecode(imap_utf7_encode($_REQUEST["infolder"] . $_SESSION["folderseparator"] . $_REQUEST["newfoldername"])));
			if ($check !== false) {
				imap_subscribe($mbox, urldecode(imap_utf7_encode($_REQUEST["infolder"] . $_SESSION["folderseparator"] . $_REQUEST["newfoldername"])));
			}
		} else {
			$check = is_createmailbox($mbox, urldecode(imap_utf7_encode($_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_REQUEST["newfoldername"])));
			if ($check !== false) {
				imap_subscribe($mbox, urldecode(imap_utf7_encode($_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_REQUEST["newfoldername"])));
			}
		}
		// close the window if we just created a folder and update the folder list
		echo("<html><head><script type=\"text/javascript\">\n");
		echo("	<!--\n");
		echo("	opener.parent.folderlist.document.location.href = 'folderlist.php';\n");
		echo("	window.close();\n");
		echo("	// -->\n");
		echo("</script></head><body></body></html>\n");
		exit;
	}

	function CreateFolderList($folderarr, $mbox) {
		$folders = getfolderlist($mbox);

		echo("	<script type=\"text/javascript\">\n");
		echo("		if (document.getElementById) {\n");
		echo("			var foldertree = new WebFXTree('Inside Systems Mail');\n");
		echo("			foldertree.setBehavior('explorer');\n");
		echo("			foldertree.action = 'javascript:SetInfolder(\'\', \'Inside Systems Mail\')';\n");
		for($i = 0; $i < count($folders); $i++) {
			echo("			var treenode" . $i . " = new WebFXTreeItem('" . addslashes($folders[$i]["name"]) . "');\n");
			if ($folders[$i]["level"] > 1) {
				for ($j = $i; $j >= 0; $j--) {
					if ($folders[$j]["level"] < $folders[$i]["level"]) {
						echo("			treenode" . $j . ".add(treenode" . $i . ");\n");
						break;
					}
				}
			} else {
				echo("			foldertree.add(treenode" . $i . ");\n");
			}
			if ($i == 0) {
				echo("			treenode" . $i . ".action = 'javascript:alert(\'" . addslashes(addslashes(gettext("You cannot create subfolders in your Inbox."))) . "\')';\n");
			} else if ($folders[$i]["folder"] != "") {
				echo("			treenode" . $i . ".action = 'javascript:SetInfolder(\'" . urlencode(addslashes($folders[$i]["folder"])) . "\', \'" . addslashes(addslashes($folders[$i]["name"])) . "\')';\n");
			}
		}
		echo("			document.write(foldertree);\n");
		echo("		}\n");
		echo("	</script>\n");
	}

	PageHeader(1);
?>
<head>
	<title><?php echo(gettext("New Folder"));?></title>
	<style type="text/css">
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/globals.css";
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/xtree.css";
		@import "themes/<?php echo($_SESSION["themedir"]);?>/css/folderlists.css";
	</style>
	<script type="text/JavaScript"> <?php include "xtree/xtree.php"; ?></script>
	<script type="text/javascript">
		<!--
		function SetInfolder(folderval, infoldername) {
			document.getElementById('createin').style.visibility = 'visible';
			document.getElementById('foldername').firstChild.nodeValue = infoldername;
			document.getElementById('infolder').value = folderval;
		}
		// -->
	</script>
</head>
<body>
<form id="folderform" name="folderform" method="post" action="newfolder.php" onsubmit="return CheckData()">
	<div id="headercontainer">
		<div id="headerleftcap">
		</div>
		<div id="headerrightcap">
		</div>
		<div id="headerlabel">
			<input type="hidden" id="infolder" name="infolder" value="none"/>
			<?php echo(gettext("Create Folder"));?>
		</div>
	</div>
	<div id="folders">
		<div id="newfolder">
			<?php echo(gettext("Name"));?>:<input type="text" id="newfoldername" name="newfoldername">
		</div>
		<div id="createin">
			<?php echo(gettext("Create in"));?>: <span id="foldername">&nbsp;</span><br/>
		</div>
		<?php
			$folders = getfolderlist($mbox);
			CreateFolderList($folders, $mbox);
		?>
	</div>
	<div id="submitinput">
		<input type="submit" value=" <?php echo(gettext("Create Folder"));?> " name="newfolder">
	</div>
</form>
<script type="text/javascript">
	<!--
	function CheckData() {
		if (document.getElementById('newfoldername').value == '') {
			alert('<?php echo(addslashes(gettext("You must enter a name for the new folder")));?>');
			return false;
		} else if (document.getElementById('infolder').value == 'none') {
			alert('<?php echo(addslashes(gettext("You must choose a location for the new folder")));?>.');
			return false;
		} else {
			return true;
		}
	}
	// -->
</script>
</body>
<?php
	// Clear the errors and close the connection
	imap_errors();
	imap_close($mbox);
?>
</html>
